//package com.nisum.webfluxmongodbordermanagement.service;
//
//import com.nisum.webfluxmongodbordermanagement.entity.Order;
//import com.nisum.webfluxmongodbordermanagement.entity.User;
//import com.nisum.webfluxmongodbordermanagement.entity.UserOrders;
//import com.nisum.webfluxmongodbordermanagement.repository.UserRepository;
//import org.junit.jupiter.api.BeforeEach;
//import org.junit.jupiter.api.Test;
//import org.junit.jupiter.api.extension.ExtendWith;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
//import org.springframework.data.mongodb.core.MongoTemplate;
//import org.springframework.data.mongodb.core.ReactiveMongoTemplate;
//import org.springframework.test.context.ActiveProfiles;
//import org.springframework.test.context.junit.jupiter.SpringExtension;
//import reactor.core.publisher.Flux;
//import reactor.test.StepVerifier;
//
//import java.io.IOException;
//
//
//@DataMongoTest
//@ExtendWith(SpringExtension.class)
//@ActiveProfiles("test")
//public class UsersOrderServiceIntTest {
//
//    static {
//        System.setProperty("spring.mongodb.embedded.version","5.0.0");
//    }
//
//    UserOrdersService userOrdersService;
//
//    @Autowired
//    private ReactiveMongoTemplate reactiveMongoTemplate;
//
//    @Autowired
//    MongoTemplate mongoTemplate;
//    @Autowired
//    UserRepository userRepository;
//
//    @BeforeEach
//    public void setup() throws IOException {
//        userOrdersService = new UserOrdersService();
//        userOrdersService.reactiveMongoTemplate = reactiveMongoTemplate;
//        mongoTemplate.getCollection("user").drop();
//        mongoTemplate.getCollection("orders").drop();
//
//        //mongoTemplate.insert(new User("23563456", "01", "samab12344","sarika@123456","1"));
//        mongoTemplate.insert(new Order("2356781", "01", "user1","ooppo122356","oppo123456","sucess"));
//        mongoTemplate.insert(new Order("2356782", "02", "user1","vivo122356","vivo123456","sucess"));
//        mongoTemplate.insert(new Order("2356783", "03", "user2","sam122356","sam123456","sucess"));
//
//        mongoTemplate.insert(new User("2356781", "user1", "sarika","sarika@123456"));
//        mongoTemplate.insert(new User("2356782", "user2", "sama","sama@123456"));
//        mongoTemplate.insert(new User("2356783", "user3", "samasarika","sama@123456"));
//
//
//
//    }
//
//
//    @Test
//    public void testGetUsers(@Autowired MongoTemplate mongoTemplate) {
//
//        // Flux<User> result = userRepository.findAll();
//        Flux<UserOrders> result = userOrdersService.getAllUsersWithOrders();
//
//
//        StepVerifier.create(result)
//                .expectNextMatches(uo -> uo.getUserId().equals("user1") && uo.getOrder().size()==2)
//                .expectNextMatches(uo -> uo.getUserId().equals("user2") && uo.getOrder().size() == 1)
//                .expectNextMatches(uo -> uo.getUserId().equals("user3") && uo.getOrder().size() == 0)
//                .expectComplete()
//                .verify();
//    }
//
//}
//
//
//
//
//



